# myApplication.py

## Python Standard Imports
'''
moved to Chapter 6 PMM 01092025
import datetime
import os
'''
import subprocess # Standard Low Level Module

## Custom Imports
import Chapter5
import Chapter6 # datetime, os, subprocess
import Chapter7


def divider():
    print('=========================')

def main(): # page 35 level 1
    # Create a new instance of a Product class and pass it args<value> <values->static,db,json,csv,...>
    #product1
    product1 = Chapter5.Product("Blue Running Shoes", 52.50, "Mens Brookes 9 Blue Running Shoes")
    #product2
    product2 = Chapter5.Product("Pink Running Shoes", 129.92, "Womens Nike Pink Running Shoes")

    # Access instance method in the Product class to show value passed
    divider()
    product1.displayProductInfo()
    divider()
    product2.displayProductInfo()
    divider()

    # Collections
    products = [
        Chapter5.Product("Mens Hat", 12.50, "Mens Blue Sport Hat"),
        Chapter5.Product("Womens Hat", 45.25, "Womens Pink Hat")
    ] # products

    for product in products: # for x in ys loop
        print("=== Product Information ===")
        print(product.displayProductInfo())
        divider()

    print("=== Product Details ===")
    productDetails1 = Chapter5.ProductDetails("Womens Hat", 45.25, "Womens Pink Hat","Blue", 52.25)
    print(productDetails1) # string method super()
    divider()

    print("==== Order Information ====")
    orderID = 1234
    orderDate = Chapter6.datetime.now()

    # Terms Net 30
    orderDueDate = orderDate + Chapter6.timedelta(days=30)

    # Create a new instance of the Orders Class and pass the local variables to the Class Object. Define the instance name newOrder
    newOrder = Chapter6.Orders(orderID,orderDate,orderDueDate)

    # call the order information
    newOrder.orderInformation()
    
    # Now that we have the order info with the price, we need to run 2 processes at the same time. subprocess page 71
    # Process 1 - Process the Credit Card
    # isolate the api into its own memory/cpu thread
    # isolating each subprocess in its own module
    creditCardProcess = subprocess.Popen(['python', 'credit_card_processor.py'])
    # Process 2 - Send the Order to the Orders DB
    orderProcess = subprocess.Popen(['python', 'order_processor.py'])

    # wait for all processes to finish before continuing
    creditCardProcess.wait()
    orderProcess.wait()

    # this line of code will not process until the waits are done
    print("All subprocesses are finished...")

    # call the lambda function from Chapter7 import
    result = Chapter7.addThreeNumbers(5,4,3) # 12
    print(result) # 12

# Application Runtime
if __name__ == "__main__":
    print('Welcome to my application')
    divider()
    main()
    divider()

# EOF